//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "svcExample2CPP.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TSampleService2 *SampleService2;
//---------------------------------------------------------------------------
__fastcall TSampleService2::TSampleService2(TComponent* Owner)
	: TNtService(Owner)
{
}
//---------------------------------------------------------------------------



void __fastcall TSampleService2::NtServiceStart(TNtService *Sender,
      bool &DoAction)
{
    int i;
    for(i=0; i < ParamCount(); i++)
        SvSendValue(dekInfo,&(Format("Params[%d]",ARRAYOFCONST((i)))[1]),Param[i],StatusHandle);
    // This service performs a very importan work at startup - it sleeps
    // (what is more important then sleep ?)
    // This work requires a lot of time so we should
    // notify the system that we are alive.
    for( i=1; i <= 10; i++)
    {
        Sleep(1000);
        ReportStatus(); // It notifies the system that we are alive
                        // The interval between calls of ReportStatus
                        // should not exceed the WaitHint value.
                        // If the service start is fast enough then this call
                        // is not necessary
    }
}
//---------------------------------------------------------------------------

void __fastcall TSampleService2::NtServiceStop(TNtService *Sender,
      bool &DoAction)
{
    int i;
    
    SvSendCheckpoint("Stopping",StatusHandle);
    // Four lines of code below demonstrates how to show the simple
    // message box from a service. Note that our service is not
    // interactive but it is able to show messages.
    DoAction =
    MessageBoxEx(0,"The SvCom example service will be stopped.\nAre you sure ?","Service confirmation",
    MB_YESNO || MB_ICONQUESTION || MB_SERVICE_NOTIFICATION,0) == IDYES;

    // The service behavior at stop is under the same
    // rules as its starting behavior.
    // For example we can do the same actions as OnStart.
    if ( DoAction )
        for( i=1; i <= 10; i++)
        {
            Sleep(1000);
            ReportStatus();
        }
    SvSendClearToCheckpoint();
}
//---------------------------------------------------------------------------

void __fastcall TSampleService2::NtServiceContinue(TNtService *Sender,
      bool &DoAction)
{
    int i;

    SvSendMethodEnter("Continue",StatusHandle);
    // And OnContinue too...
    for(i=1; i <= 10; i++)
    {
        Sleep(1000);
        ReportStatus();
    }
    SvSendMethodLeave("Continue",StatusHandle);
}
//---------------------------------------------------------------------------

void __fastcall TSampleService2::NtServicePause(TNtService *Sender,
      bool &DoAction)
{
    int i;
    // As well as OnPause...
    for (i=1; i <= 10; i++)
    {
        Sleep(1000);
        ReportStatus();
        SvSendValue(dekInfo,"i",i,StatusHandle);
    }
}
//---------------------------------------------------------------------------

void __fastcall TSampleService2::NtServiceExecute(TObject *Sender)
{
    // The OnExecute method can perform some work too.
    // But in this case we need not report service status,
    // we only need process the service control requests.
    // To do it we call the ProcessRequests method with False parameter.
    // It means that we do not wait the messages. Note that the True parameter
    // means that the ProcessRequests call should not return until service stopped -
    // and may be sure - it will not return.
    while ( ! Terminated() )
    {
        ProcessRequests(False);
        Sleep(1000);
        SvSendMessage(dekWarning,"It is running",StatusHandle);
    }
}
//---------------------------------------------------------------------------

